#ifndef PHOEBE_ACCESSORIES_H
	#define PHOEBE_ACCESSORIES_H 1

#include "phoebe_global.h"

int   filename_exists                  (char *filename);
int   filename_has_write_permissions   (char *filename);
int   filename_has_read_permissions    (char *filename);
int   filename_has_execute_permissions (char *filename);
int   filename_has_full_permissions    (char *filename);
int   filename_is_directory            (char *filename);
int   filename_is_regular_file         (char *filename);
char *get_current_working_directory    ();
char *resolve_relative_filename        (char *filename);
int   list_directory_contents          (char *dir);
char *concatenate_strings              (const char *str, ...);

double      phoebe_data_min            (PHOEBE_data data);
double      phoebe_data_max            (PHOEBE_data data);
double      phoebe_data_median         (PHOEBE_data data);

int         phoebe_data_add            (PHOEBE_data *to, PHOEBE_data one, PHOEBE_data two);
int         phoebe_data_subtract       (PHOEBE_data *to, PHOEBE_data one, PHOEBE_data two);
int         phoebe_data_multiply       (PHOEBE_data *to, PHOEBE_data one, PHOEBE_data two);
int         phoebe_data_divide         (PHOEBE_data *to, PHOEBE_data one, PHOEBE_data two);

#endif
