#ifndef PHOEBE_ALLOCATIONS_H
	#define PHOEBE_ALLOCATIONS_H

#include "phoebe_global.h"

char  *parse_data_line               (char *in);
int    read_in_synthetic_data        (PHOEBE_data *data, int curve, PHOEBE_output_indep indep, PHOEBE_output_dep dep, PHOEBE_output_weight weight);
int    read_in_experimental_data     (char *filename, PHOEBE_data *data, int indep, int outindep, int dep, int outdep, int weight, int outweight);
int    read_in_ephemeris_parameters  (double *hjd0, double *period, double *dpdt, double *pshift);
int    read_in_adjustable_parameters (double **values, int **indices);

int    get_passband_id               (char *passband);
double get_passband_wavelength       (char *passband);
int    get_level_weighting_id        (char *type);

int    read_in_wd_lci_parameters     (WD_LCI_parameters *params, int MPAGE, int curve);
int    read_in_wd_dci_parameters     (WD_DCI_parameters *params);

int    wd_dci_parameters_free        (WD_DCI_parameters *params);

#endif
