#ifndef PHOEBE_FITTING_H
	#define PHOEBE_FITTING_H

#include <stdarg.h>

#ifdef HAVE_LIBGSL
	#ifndef PHOEBE_GSL_DISABLED
		#include <gsl/gsl_rng.h>
	#endif
#endif

int find_minimum_with_nms (double accuracy, int iter_no, double *final_chi2);
int find_minimum_with_dc  (double *chi2ret);
int kick_parameters (double sigma);
int nms_print (const char *fmt, ...);

#ifdef HAVE_LIBGSL
	#ifndef PHOEBE_GSL_DISABLED
		gsl_rng *PHOEBE_randomizer;
	#endif
#endif

#endif
