%{
#include <stdio.h>
#include <string.h>
%}

%option prefix="convert_0_2x_to_0_30pre3"

DIGIT [0-9]

%%

\"{DIGIT}+.{DIGIT}+\"	{ double val; sscanf (yytext, "\"%lf\"", &val); printf ("%lf", val); }

NAME		printf ("phoebe_name");
MODEL		printf ("phoebe_model");
LCNO		printf ("phoebe_lcno");
RVNO		printf ("phoebe_rvno");
SPECNO		printf ("phoebe_spno");
MNORM		printf ("phoebe_mnorm");
BINNING		printf ("phoebe_bins_switch");
BINVAL		printf ("phoebe_bins");
REDDENING		printf ("phoebe_ie_switch");
REDDENING_R		printf ("phoebe_ie_factor");
REDDENING_E		printf ("phoebe_ie_excess");
LCCOL1{DIGIT}+	{ int idx; char *ptr = yytext+ 6; sscanf (ptr, "%d", &idx); printf ("phoebe_lc_indep[%d]", idx); }
LCCOL2{DIGIT}+	{ int idx; char *ptr = yytext+ 6; sscanf (ptr, "%d", &idx); printf ("phoebe_lc_dep[%d]", idx); }
LCCOL3{DIGIT}+	{ int idx; char *ptr = yytext+ 6; sscanf (ptr, "%d", &idx); printf ("phoebe_lc_indweight[%d]", idx); }
LCFN{DIGIT}+	{ int idx; char *ptr = yytext+ 4; sscanf (ptr, "%d", &idx); printf ("phoebe_lc_filename[%d]", idx); }
LCSIG{DIGIT}+	{ int idx; char *ptr = yytext+ 5; sscanf (ptr, "%d", &idx); printf ("phoebe_lc_sigma[%d]", idx); }
LCFLT{DIGIT}+	{ int idx; char *ptr = yytext+ 5; sscanf (ptr, "%d", &idx); printf ("phoebe_lc_filter[%d]", idx); }
WEIGHT{DIGIT}+	{ int idx; char *ptr = yytext+ 6; sscanf (ptr, "%d", &idx); printf ("phoebe_lc_levweight[%d]", idx); }
RVCOL1{DIGIT}+	{ int idx; char *ptr = yytext+ 6; sscanf (ptr, "%d", &idx); printf ("phoebe_rv_indep[%d]", idx); }
RVCOL2{DIGIT}+	{ int idx; char *ptr = yytext+ 6; sscanf (ptr, "%d", &idx); printf ("phoebe_rv_dep[%d]", idx); }
RVCOL3{DIGIT}+	{ int idx; char *ptr = yytext+ 6; sscanf (ptr, "%d", &idx); printf ("phoebe_rv_indweight[%d]", idx); }
RVFN{DIGIT}+	{ int idx; char *ptr = yytext+ 4; sscanf (ptr, "%d", &idx); printf ("phoebe_rv_filename[%d]", idx); }
RVSIG{DIGIT}+	{ int idx; char *ptr = yytext+ 5; sscanf (ptr, "%d", &idx); printf ("phoebe_rv_sigma[%d]", idx); }
RVFLT{DIGIT}+	{ int idx; char *ptr = yytext+ 5; sscanf (ptr, "%d", &idx); printf ("phoebe_rv_filter[%d]", idx); }
HJD0[ \t]+		printf ("phoebe_hjd0.VAL");
HJD0_ADJ		printf ("phoebe_hjd0.ADJ");
HJD0_DEL		printf ("phoebe_hjd0.STEP");
HJD0_MIN		printf ("phoebe_hjd0.MIN");
HJD0_MAX		printf ("phoebe_hjd0.MAX");
PERIOD[ \t]+	printf ("phoebe_period.VAL");
PERIOD_ADJ		printf ("phoebe_period.ADJ");
PERIOD_DEL		printf ("phoebe_period.STEP");
PERIOD_MIN		printf ("phoebe_period.MIN");
PERIOD_MAX		printf ("phoebe_period.MAX");
DPDT[ \t]+		printf ("phoebe_dpdt.VAL");
DPDT_ADJ		printf ("phoebe_dpdt.ADJ");
DPDT_DEL		printf ("phoebe_dpdt.STEP");
DPDT_MIN		printf ("phoebe_dpdt.MIN");
DPDT_MAX		printf ("phoebe_dpdt.MAX");
PSHIFT[ \t]+	printf ("phoebe_pshift.VAL");
PSHIFT_ADJ		printf ("phoebe_pshift.ADJ");
PSHIFT_DEL		printf ("phoebe_pshift.STEP");
PSHIFT_MIN		printf ("phoebe_pshift.MIN");
PSHIFT_MAX		printf ("phoebe_pshift.MAX");
SMA[ \t]+		printf ("phoebe_sma.VAL");
SMA_ADJ		printf ("phoebe_sma.ADJ");
SMA_DEL		printf ("phoebe_sma.STEP");
SMA_MIN		printf ("phoebe_sma.MIN");
SMA_MAX		printf ("phoebe_sma.MAX");
RM[ \t]+		printf ("phoebe_rm.VAL");
RM_ADJ		printf ("phoebe_rm.ADJ");
RM_DEL		printf ("phoebe_rm.STEP");
RM_MIN		printf ("phoebe_rm.MIN");
RM_MAX		printf ("phoebe_rm.MAX");
INCL[ \t]+		printf ("phoebe_incl.VAL");
INCL_ADJ		printf ("phoebe_incl.ADJ");
INCL_DEL		printf ("phoebe_incl.STEP");
INCL_MIN		printf ("phoebe_incl.MIN");
INCL_MAX		printf ("phoebe_incl.MAX");
VGA[ \t]+		printf ("phoebe_vga.VAL");
VGA_ADJ		printf ("phoebe_vga.ADJ");
VGA_DEL		printf ("phoebe_vga.STEP");
VGA_MIN		printf ("phoebe_vga.MIN");
VGA_MAX		printf ("phoebe_vga.MAX");
TAVH[ \t]+		printf ("phoebe_teff1.VAL");
TAVH_ADJ		printf ("phoebe_teff1.ADJ");
TAVH_DEL		printf ("phoebe_teff1.STEP");
TAVH_MIN		printf ("phoebe_teff1.MIN");
TAVH_MAX		printf ("phoebe_teff1.MAX");
TAVC[ \t]+		printf ("phoebe_teff2.VAL");
TAVC_ADJ		printf ("phoebe_teff2.ADJ");
TAVC_DEL		printf ("phoebe_teff2.STEP");
TAVC_MIN		printf ("phoebe_teff2.MIN");
TAVC_MAX		printf ("phoebe_teff2.MAX");
PHSV[ \t]+		printf ("phoebe_pot1.VAL");
PHSV_ADJ		printf ("phoebe_pot1.ADJ");
PHSV_DEL		printf ("phoebe_pot1.STEP");
PHSV_MIN		printf ("phoebe_pot1.MIN");
PHSV_MAX		printf ("phoebe_pot1.MAX");
PCSV[ \t]+		printf ("phoebe_pot2.VAL");
PCSV_ADJ		printf ("phoebe_pot2.ADJ");
PCSV_DEL		printf ("phoebe_pot2.STEP");
PCSV_MIN		printf ("phoebe_pot2.MIN");
PCSV_MAX		printf ("phoebe_pot2.MAX");
LOGG1[ \t]+		printf ("phoebe_logg1.VAL");
LOGG1_ADJ		printf ("phoebe_logg1.ADJ");
LOGG1_DEL		printf ("phoebe_logg1.STEP");
LOGG1_MIN		printf ("phoebe_logg1.MIN");
LOGG1_MAX		printf ("phoebe_logg1.MAX");
LOGG2[ \t]+		printf ("phoebe_logg2.VAL");
LOGG2_ADJ		printf ("phoebe_logg2.ADJ");
LOGG2_DEL		printf ("phoebe_logg2.STEP");
LOGG2_MIN		printf ("phoebe_logg2.MIN");
LOGG2_MAX		printf ("phoebe_logg2.MAX");
MET1[ \t]+		printf ("phoebe_met1.VAL");
MET1_ADJ		printf ("phoebe_met1.ADJ");
MET1_DEL		printf ("phoebe_met1.STEP");
MET1_MIN		printf ("phoebe_met1.MIN");
MET1_MAX		printf ("phoebe_met1.MAX");
MET2[ \t]+		printf ("phoebe_met2.VAL");
MET2_ADJ		printf ("phoebe_met2.ADJ");
MET2_DEL		printf ("phoebe_met2.STEP");
MET2_MIN		printf ("phoebe_met2.MIN");
MET2_MAX		printf ("phoebe_met2.MAX");
E[ \t]+		printf ("phoebe_ecc.VAL");
E_ADJ		printf ("phoebe_ecc.ADJ");
E_DEL		printf ("phoebe_ecc.STEP");
E_MIN		printf ("phoebe_ecc.MIN");
E_MAX		printf ("phoebe_ecc.MAX");
PERR0[ \t]+		printf ("phoebe_perr0.VAL");
PERR0_ADJ		printf ("phoebe_perr0.ADJ");
PERR0_DEL		printf ("phoebe_perr0.STEP");
PERR0_MIN		printf ("phoebe_perr0.MIN");
PERR0_MAX		printf ("phoebe_perr0.MAX");
DPERDT[ \t]+	printf ("phoebe_dperdt.VAL");
DPERDT_ADJ		printf ("phoebe_dperdt.ADJ");
DPERDT_DEL		printf ("phoebe_dperdt.STEP");
DPERDT_MIN		printf ("phoebe_dperdt.MIN");
DPERDT_MAX		printf ("phoebe_dperdt.MAX");
F1[ \t]+		printf ("phoebe_f1.VAL");
F1_ADJ		printf ("phoebe_f1.ADJ");
F1_DEL		printf ("phoebe_f1.STEP");
F1_MIN		printf ("phoebe_f1.MIN");
F1_MAX		printf ("phoebe_f1.MAX");
F2[ \t]+		printf ("phoebe_f2.VAL");
F2_ADJ		printf ("phoebe_f2.ADJ");
F2_DEL		printf ("phoebe_f2.STEP");
F2_MIN		printf ("phoebe_f2.MIN");
F2_MAX		printf ("phoebe_f2.MAX");
HLALC{DIGIT}+	{ int idx; char *ptr = yytext+ 5; sscanf (ptr, "%d", &idx); printf ("phoebe_hla[%d].VAL", idx); }
HLA_ADJ		printf ("phoebe_hla.ADJ");
HLA_DEL		printf ("phoebe_hla.STEP");
CLALC{DIGIT}+	{ int idx; char *ptr = yytext+ 5; sscanf (ptr, "%d", &idx); printf ("phoebe_cla[%d].VAL", idx); }
CLA_ADJ		printf ("phoebe_cla.ADJ");
CLA_DEL		printf ("phoebe_cla.STEP");
EL3{DIGIT}+		{ int idx; char *ptr = yytext+ 3; sscanf (ptr, "%d", &idx); printf ("phoebe_el3[%d].VAL", idx); }
EL3_ADJ		printf ("phoebe_el3.ADJ");
EL3_DEL		printf ("phoebe_el3.STEP");
OPSF{DIGIT}+	{ int idx; char *ptr = yytext+ 4; sscanf (ptr, "%d", &idx); printf ("phoebe_opsf[%d].VAL", idx); }
OPSF_ADJ		printf ("phoebe_opsf.ADJ");
OPSF_DEL		printf ("phoebe_opsf.STEP");
IPB_ON		printf ("phoebe_usecla_switch");
NREF_ON		printf ("phoebe_reffect_switch");
NREF_VAL		printf ("phoebe_reffect_reflections");
IFAT1_ON		printf ("phoebe_atm1_switch");
IFAT2_ON		printf ("phoebe_atm2_switch");
NOISE_ON		printf ("phoebe_synscatter_switch");
NOISE_TYPE		printf ("phoebe_synscatter_levweight");
NOISE_VAL		printf ("phoebe_synscatter_sigma");
SEED_VAL		printf ("phoebe_synscatter_seed");
ICOR1_ON		printf ("phoebe_proximity_rv1_switch");
ICOR2_ON		printf ("phoebe_proximity_rv2_switch");
LD		printf ("phoebe_ld_model");
XBOL1		printf ("phoebe_ld_xbol1");
XBOL2		printf ("phoebe_ld_xbol2");
YBOL1		printf ("phoebe_ld_ybol1");
YBOL2		printf ("phoebe_ld_ybol2");
X1ALC{DIGIT}+	{ int idx; char *ptr = yytext+ 5; sscanf (ptr, "%d", &idx); printf ("phoebe_ld_lcx1[%d].VAL", idx); }
X2ALC{DIGIT}+	{ int idx; char *ptr = yytext+ 5; sscanf (ptr, "%d", &idx); printf ("phoebe_ld_lcx2[%d].VAL", idx); }
Y1ALC{DIGIT}+	{ int idx; char *ptr = yytext+ 5; sscanf (ptr, "%d", &idx); printf ("phoebe_ld_lcy1[%d].VAL", idx); }
Y2ALC{DIGIT}+	{ int idx; char *ptr = yytext+ 5; sscanf (ptr, "%d", &idx); printf ("phoebe_ld_lcy2[%d].VAL", idx); }
X1ARV{DIGIT}+	{ int idx; char *ptr = yytext+ 5; sscanf (ptr, "%d", &idx); printf ("phoebe_ld_rvx1[%d].VAL", idx); }
X2ARV{DIGIT}+	{ int idx; char *ptr = yytext+ 5; sscanf (ptr, "%d", &idx); printf ("phoebe_ld_rvx2[%d].VAL", idx); }
Y1ARV{DIGIT}+	{ int idx; char *ptr = yytext+ 5; sscanf (ptr, "%d", &idx); printf ("phoebe_ld_rvy1[%d].VAL", idx); }
Y2ARV{DIGIT}+	{ int idx; char *ptr = yytext+ 5; sscanf (ptr, "%d", &idx); printf ("phoebe_ld_rvy2[%d].VAL", idx); }
X1A_DEL		printf ("phoebe_ld_lcx1.STEP");
X2A_DEL		printf ("phoebe_ld_lcx2.STEP");
X1A_ADJ		printf ("phoebe_ld_lcx1.ADJ");
X2A_ADJ		printf ("phoebe_ld_lcx2.ADJ");
ALB1[ \t]+		printf ("phoebe_alb1.VAL");
ALB1_ADJ		printf ("phoebe_alb1.ADJ");
ALB1_DEL		printf ("phoebe_alb1.STEP");
ALB1_MIN		printf ("phoebe_alb1.MIN");
ALB1_MAX		printf ("phoebe_alb1.MAX");
ALB2[ \t]+		printf ("phoebe_alb2.VAL");
ALB2_ADJ		printf ("phoebe_alb2.ADJ");
ALB2_DEL		printf ("phoebe_alb2.STEP");
ALB2_MIN		printf ("phoebe_alb2.MIN");
ALB2_MAX		printf ("phoebe_alb2.MAX");
GR1[ \t]+		printf ("phoebe_grb1.VAL");
GR1_ADJ		printf ("phoebe_grb1.ADJ");
GR1_DEL		printf ("phoebe_grb1.STEP");
GR1_MIN		printf ("phoebe_grb1.MIN");
GR1_MAX		printf ("phoebe_grb1.MAX");
GR2[ \t]+		printf ("phoebe_grb2.VAL");
GR2_ADJ		printf ("phoebe_grb2.ADJ");
GR2_DEL		printf ("phoebe_grb2.STEP");
GR2_MIN		printf ("phoebe_grb2.MIN");
GR2_MAX		printf ("phoebe_grb2.MAX");
NSPOTSPRIM		printf ("phoebe_spots_no1");
NSPOTSSEC		printf ("phoebe_spots_no2");
N1_VAL		printf ("phoebe_grid_finesize1");
N2_VAL		printf ("phoebe_grid_finesize2");
N1L_VAL		printf ("phoebe_grid_coarsesize1");
N2L_VAL		printf ("phoebe_grid_coarsesize2");

JDPHS_TIME" "*"="" "*{DIGIT}+	{ int idx; sscanf (yytext, "phoebe_indep = %d", &idx); if (idx == 1) printf ("phoebe_indep = \"Time (HJD)\""); else printf ("phoebe_indep = \"Phase\""); }

"Time"		printf ("Time (HJD)");

"Weight (int)"	printf ("Standard weight (integer)");
"Weight (real)"	printf ("Standard weight (double)");
"Absolute error"	printf ("Standard deviation (sigma)");

"RV in km/s"	printf ("[CHANGED IN 0.30]");

"Linear Cosine Law"	printf ("Linear cosine law");
"Logarithmic Law"	printf ("Logarighmic law");
"Square Root Law"	printf ("Square root law");

"General binary system (no constraints)"	printf ("Unconstrained binary system");

"No Level-Dependent Weighting"	printf ("No level-dependent weighting");
"Scatter scales with square root"	printf ("Poissonian scatter");
"Scatter scales with light level"	printf ("Low light scatter");

XLAMDA_VAL[^\n]*"\n"
ISYM_ON[^\n]*"\n"
LC_PHSTRT[^\n]*"\n"
LC_PHEND[^\n]*"\n"
LC_VERTICES[^\n]*"\n"
LC_INDEP[^\n]*"\n"
LC_DEP[^\n]*"\n"
PHNORM_VAL[^\n]*"\n"
FACTOR_VAL[^\n]*"\n"
RV_PHSTRT[^\n]*"\n"
RV_PHEND[^\n]*"\n"
RV_VERTICES[^\n]*"\n"
RV_INDEP[^\n]*"\n"
RV_DEP[^\n]*"\n"
MODELLGG_ON[^\n]*"\n"
THE_VAL[^\n]*"\n"

%%
